//**********************************
// ChainLine2.pas
// ChainLine2.bmp
// ChainLinePar2.bmp
// Alpha Seikou CO.,LTD.(2001/03/30)
//**********************************

program ChainLine;

var
  // _CAO{bNXœ͂鍽̏
  intChainType: Integer; // n_
  dobSolid: Double; // H̒
  dobChain: Double; // ̒
  dobSpace: Double; // Xy[X̒
  
  // ̂PTCN
  dobLineCycle: Double;
  
  // ֊svfi[p
  intContLen   : Integer;
  
  // vff[^
  intType: Integer;
  dobV1, dobV2, dobV3, dobV4, dobV5 : Double;
  
  // JԂp
  intK : Integer;


// `p**************************
procedure LineDraw(x1, y1, x2, y2: Double);
var
  // [Jϐ
  myLength : Double;
  myAngle : Double;
  myDiv : Integer;
  mySur : Double;
  myAdd : Double;
  mySolid : Double;
  i, j : Integer;
begin
  // ̒
  myLength := Distance(x1, y1, x2, y2);
  
  // (TCN+)Zꍇ͎`悷
  if (myLength < (dobLineCycle + dobSolid)) then
  begin
    Line(x1, y1, x2, y2);
    Exit;
  end;
  
  // ͂ꂽ񂩂Q_Ԃ̊pxvZ
  myAngle := PosToAngl(x1, y1, x2, y2);
  // ̂PTCN͈͓Ŏ邩vZ
  myDiv := Trunc((myLength - dobSolid) / dobLineCycle);
  // ]̐@vZ
  mySur := myLength - (myDiv * dobLineCycle) - dobSolid;
  // ]̐@ɐU蕪
  myAdd := mySur / (myDiv + 1);
  mySolid := dobSolid + myAdd;
  // `px]
  Rotation(x1, y1, myAngle);
  
  // JԂŎ{{Xy[X`悷
  for i := 1 to myDiv do
  begin
    Line(x1, y1, x1 + mySolid, y1);
    x1 := x1 + mySolid;
    
    for j := 1 to intChainType do
    begin
      x1 := x1 + dobSpace;
      Line(x1, y1, x1 + dobChain, y1);
      x1 := x1 + dobChain;
    end;
    
    x1 := x1 + dobSpace;
  end;
  // ŌɎP`悷
  Line(x1, y1, (x1 + mySolid), y1);
end;


// ~ʕ`p**************************
procedure ArcDraw(x, y, r, sa, ea: Double);
var
  // [Jϐ
  myLength : Double;
  myAngle : Double;
  myDiv : Integer;
  mySur : Double;
  myAdd : Double;
  mySolid : Double;
  i, j : Integer;
begin
  // px
  myAngle := ea - sa;
  // ̒
  myLength := (r * 2.0 * PI) * (myAngle / 360.0);
  
  // (TCN+)Zꍇ͎`悷
  if (myLength < (dobLineCycle + dobSolid)) then
  begin
    Arc(x, y, r, sa, ea);
    Exit;
  end;
  
  //  ̂PTCN͈͓Ŏ邩vZ
  myDiv := Trunc((myLength - dobSolid) / dobLineCycle);
  // ]̐@vZ
  mySur := myLength - (myDiv * dobLineCycle) - dobSolid;
  // ]̐@ɐU蕪
  myAdd := mySur / (myDiv + 1);
  mySolid := dobSolid + myAdd;
  
  // JԂŎ{{Xy[X`悷
  for i := 1 to myDiv do
  begin
    ea := sa + (mySolid / myLength * myAngle);
    Arc(x, y, r, sa, ea);
    
    for j := 1 to intChainType do
    begin
      sa := ea + (dobSpace / myLength * myAngle);
      ea := sa + (dobChain / myLength * myAngle);
      Arc(x, y, r, sa, ea);
    end;
    
    sa := ea + (dobSpace / myLength * myAngle);
  end;
  ea := sa + (mySolid / myLength * myAngle);
  // ŌɎP`悷
  Arc(x, y, r, sa, ea);
end;


// ~`p**************************
procedure CircleDraw(x, y, r: Double);
var
  // [Jϐ
  myLength : Double;
  myAngle : Double;
  myDiv : Integer;
  mySur : Double;
  myAdd : Double;
  mySolid : Double;
  i, j : Integer;
  sa, ea : Double;
begin
  // ̒
  myLength := (r * 2.0 * PI);
  
  // (TCN)Zꍇ͎`悷
  if (myLength < dobLineCycle) then
  begin
    Circle(x, y, r);
    Exit;
  end;
  
  // px
  myAngle := 360.0;
  //  ̂PTCN͈͓Ŏ邩vZ
  myDiv := Trunc(myLength / dobLineCycle);
  // ]̐@vZ
  mySur := myLength - (myDiv * dobLineCycle);
  // ]̐@ɐU蕪
  myAdd := mySur / myDiv;
  mySolid := dobSolid + myAdd;
  
  sa := 0.0;
  
  // JԂŎ{{Xy[X`悷
  for i := 1 to myDiv do
  begin
    ea := sa + (mySolid / myLength * myAngle);
    Arc(x, y, r, sa, ea);
    
    for j := 1 to intChainType do
    begin
      sa := ea + (dobSpace / myLength * myAngle);
      ea := sa + (dobChain / myLength * myAngle);
      Arc(x, y, r, sa, ea);
    end;
    
    sa := ea + (dobSpace / myLength * myAngle);
  end;
end;


// CvO********************
begin
  InitDlg; // _CAȌ
  
  // _CAO̕`
  AddLabel(20,  20, 220, 20, 'PF̐͂Ă');
  AddLabel(20,  50, 220, 20, 'QF̒͂ĉ');
  AddLabel(20,  80, 220, 20, 'RF̒͂Ă');
  AddLabel(20, 110, 220, 20, 'SFXy[X͂ĉ');
  
  // l [3] [5.0] [1.0] [0.5] ɂĂ܂BCӂɕςāII
  AddEdit(1, 250,  20, 40, 20, '3');
  AddEdit(2, 250,  50, 40, 20, '5.0');
  AddEdit(3, 250,  80, 40, 20, '1.0');
  AddEdit(4, 250, 110, 40, 20, '0.5');
  
  AddImage(300, 20, 'ChainLinePar2.bmp');
  
  // _CAOLZꂽI܂
  if (ShowDlg(420, 180, '̓') <> true) then
    Exit;
  
  // ͂ꂽϐɊi[
  intChainType := StrToInt(GetDlgText(1));   // ̐
  dobSolid     := StrToFloat(GetDlgText(2)); // ̒
  dobChain     := StrToFloat(GetDlgText(3)); // ̒
  dobSpace     := StrToFloat(GetDlgText(4)); // Xy[X
  
  // ͂ꂽ̏EEECӂɐݒ聚
  // ̃^CvA1           5܂łɂĂ܂lB
  if ((intChainType < 1) or (intChainType > 5)) then
  begin
    OkMsgBox('̐́A1`5 ɂĉB');
    Exit;
  end;
  // ̒ 5.0           10.0܂łɂĂ܂lB
  if ((dobSolid < 5.0) or (dobSolid > 10.0)) then
  begin
    OkMsgBox('H̒́A5.0`10.0 ܂łł');
    Exit;
  end;
  // ̒ 1.0           3.0܂łɂĂ܂lB
  if ((dobChain < 1.0) or (dobChain > 3.0)) then
  begin
    OkMsgBox('̒́A1.0`3.0 ܂łł');
    Exit;
  end;
  // Xy[X0.5          2.0܂łɂĂ܂lB
  if ((dobSpace < 0.5) or (dobSpace > 2.0)) then
  begin
    OkMsgBox('Xy[X̒́A0.5`2.0 ܂łł');
    Exit;
  end;
  // 
  
  // ̂PTCN̒vZ {{Xy[X
  dobLineCycle := dobSolid + 
                  (dobChain * intChainType) + 
                  (dobSpace * (intChainType + 1));
  LineType(0);
  
  while true do
  begin
    // ֊s擾
    Message('ύXvfI');
    
    // ֊s擾ŝƂXNvg~{^ŏI
    if (ContSeek(intContLen) = 0) then Exit;
    
    // ֊s擾̊mF
    if MsgBox('擾֊svf ' + IntToStr(intContLen) +
              ' ł' + #13#10 + 'ǂ[OK]AIȂ' +
               '[LZ]Ă') then
    
    for intK := 0 to intContLen - 1 do
    begin
      ContInfo(intK, intType, dobV1, dobV2, dobV3, dobV4, dobV5);
      
      case intType of 
        1: // 
          LineDraw(dobV1, dobV2, dobV3, dobV4);
        2: // cw~
          ArcDraw(dobV1, dobV2, dobV3, dobV4, dobV5);
        3: // ccw~
          ArcDraw(dobV1, dobV2, dobV3, dobV4, dobV5);
        4: // ~
          CircleDraw(dobV1, dobV2, dobV3);
      end;
      //}]ftHgɖ߂
      Rotation(0.0, 0.0, 0.0);
    end;
  
  if (MsgBox('܂H') <> true) then Exit;
  
  end;
end.
